#include <stralloc.h>
#include <stdio.h>

int readline(FILE* fp, stralloc* sa) {
	sa->len = 0;
	for(;;) {
		if(!stralloc_readyplus(sa, 1)) return 0;
		if(fread(sa->s + sa->len, sizeof(char), 1 , fp) <=0) return 0;
		if(sa->s[sa->len] == '\n') break;
		++sa->len;
	}
	return 1;
}

int main(int argc, char* argv[]) {
	FILE* fp = fopen(argv[1], "r");

	stralloc sa = {0};
	while(readline(fp, &sa)) {
	
		printf("%s", sa.s);	
		stralloc_init(&sa);
	}

	fclose(fp);
}
